image: node:16

before_script:
  - apt-get update
  - apt-get install zip

cache:
  paths:
    - node_modules/

stages:
  - init
  - build
  - deploy

## Disabled the beta jobs in favor of explicit tags.

# init-beta:
#   stage: init
#   image: docker:latest
#   variables:
#     VAR_NAME: BETA_BUILD_NUMBER
#     TOKEN: ${CI_PIPELINE_IID_TOKEN}
#     GITLAB_URL: "https://gitlab.com"
#   before_script:
#   - apk add --update curl jq
#   script:
#   - "VAR=$(curl -s -f  --header \"PRIVATE-TOKEN: ${TOKEN}\" \"${GITLAB_URL}/api/v4/projects/${CI_PROJECT_ID}/variables/${VAR_NAME}\" | jq  -r '.value' ) "
#   - let VAR=VAR+1
#   - "curl -s -f --request PUT --header \"PRIVATE-TOKEN: ${TOKEN}\" \"${GITLAB_URL}/api/v4/projects/${CI_PROJECT_ID}/variables/${VAR_NAME}\" --form \"value=${VAR}\" "
#   only:
#     - beta

# build-beta:
#   stage: build
#   script:
#     - export
#     - npm ci
#     - npm run build
#     - node update-build-tags.js --branch=$CI_COMMIT_BRANCH --gitlabpath=$CI_PROJECT_PATH --jobname=$CI_JOB_NAME --versionpre=$BETA_BUILD_NUMBER
#     - cp ./dist/system.json ./system.json
#     - mv dist dungeonworld
#     - zip -q dungeonworld.zip -r dungeonworld
#   artifacts:
#     paths:
#       - dungeonworld.zip
#       - system.json
#   only:
#     - beta

build-prod:
  stage: build
  script:
    - export
    - npm ci
    - npm run build
    - node update-build-tags.js --branch=$CI_COMMIT_BRANCH --gitlabpath=$CI_PROJECT_PATH --jobname=$CI_JOB_NAME  --tag=$CI_COMMIT_TAG --bucket=$S3_BUCKET
    - cp ./dist/system.json ./system.json
    - mv dist dungeonworld
    - zip -q dungeonworld.zip -r dungeonworld
  artifacts:
    paths:
      - dungeonworld.zip
      - system.json
  only:
    - tags

deploy-beta:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  dependencies:
    - build-prod
  script:
    - BRANCH=$(./get-version.sh)
    - aws configure set region us-east-1
    # Write the tagged artifact and manifest.
    - aws s3 cp ./dungeonworld.zip s3://$S3_BUCKET/dungeonworld/$CI_COMMIT_TAG/dungeonworld.zip --acl="public-read"
    - aws s3 cp ./system.json s3://$S3_BUCKET/dungeonworld/$CI_COMMIT_TAG/system.json --acl="public-read"
    # Write the general beta/alpha manifest.
    - aws s3 cp ./system.json s3://$S3_BUCKET/dungeonworld/$BRANCH/system.json --acl="public-read"
  only:
    # Examples: 0.1.0, 0.1.2.beta-1, 0.3.4.alpha
    # Unlike the build script, this _only_ runs on beta/alpha tags.
    - /^(\d+\.)+(\d+)*((beta|alpha)+(([-.v])*\d+)+)*$/i
  except:
    - branches